def list = [1, 2, 3, 5, 4, 6, 7, 8, 9, 10]

//Collection with eager evaluation in Groovy
println(list.findAll { it > 3 })

//Pipeline stream with lazy evaluation in Java
println(
  list.stream()
      .filter { it > 3 })

//Both in life and coding, it's good to be lazy
def isGT3 = {
  println "isGT3 $it"
  it > 3
}

def isEven = {
  println "isEven $it"
  it % 2 == 0
}

def doubleIt = {
  println "isGT3 $it"
  it * 2
}

println 'Groovy Facade'
println(
  list.findAll(isGT3)
      .findAll(isEven)
      .collect(doubleIt)
      .first())

println 'Java Stream'
println(
  list.stream()
      .filter(isGT3)
      .filter(isEven)
      .map(doubleIt)
      .findFirst()
      .orElse(0))

